/*******************************************************************************
* Copyright (c)                                                                *
*           2005   Tristan Allwood,                                            *
*           2005   Daniel Burke,                                               *
*           2005   Marc Hull,                                                  *
*           2005   Ekaterina Itskova,                                          *
*           2005   Steve Zymler                                                *
*                                                                              *
* Permission is hereby granted, free of charge, to any person obtaining a      *
* copy of this software and associated documentation files (the                *
* "Software"), to deal in the Software without restriction, including          *
* without limitation the rights to use, copy, modify, merge, publish,          *
* distribute, sublicense, and/or sell copies of the Software, and to           *
* permit persons to whom the Software is furnished to do so, subject to        *
* the following conditions:                                                    *
*                                                                              *
* The above copyright notice and this permission notice shall be included      *
* in all copies or substantial portions of the Software.                       *
*                                                                              *
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS      *
* OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF                   *
* MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.       *
* IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY         *
* CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,         *
* TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE            *
* SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                       *
*******************************************************************************/
/*
 * Created on 20-Oct-2004
 *
 */
package uk.ac.ic.doc.kevlar.gui;

import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;

import uk.ac.ic.doc.kevlar.gui.internal.CanvasManager;
import uk.ac.ic.doc.kevlar.gui.internal.caches.ImageCache;
import uk.ac.ic.doc.kevlar.gui.internal.pipeline.PipeLineManager;
import uk.ac.ic.doc.kevlar.hial.HialProvider;
import uk.ac.ic.doc.kevlar.hial.IHial;
import uk.ac.ic.doc.kevlar.hial.IHialContext;


/**
 * @author mfh02
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class GUIManager {

	static IHial hial;
	static IHialContext hialContext;
	
	public static IHial getHial()
	{
		return hial;
	}
	
	public static IHialContext getHialContext()
	{
	    
	    if (hialContext == null) {
	        
	        hialContext = hial.createNewContext(PipeLineManager.getSingleton());
	        
	    }
	    
		return hialContext;
	}
	
	public static void main(String[] args) {

		hial = HialProvider.makeAHial();
	    
		try {
		
			Display d = new Display();
			Shell s = new Shell(d);
			s.setImage(ImageCache.get("icon.png"));
			s.setText("Kevlar");
	
			GridLayout grid = new GridLayout(1, true);
			grid.horizontalSpacing = 0;
			grid.verticalSpacing = 0;
			grid.marginWidth = 0;
			grid.marginHeight = 0;
			s.setLayout(grid);
			s.setSize(600, 400);

//			new ToolBarManager(s);
			CanvasManager.createSingleton(s);

			s.layout();
			s.open();
			
			// This stack variable is useful when suspending the
			// main thread in the debugger
			CanvasManager canvasManager = CanvasManager.getSingleton();
		
			while (!s.isDisposed()) {
			
				if (!d.readAndDispatch()) {
				
					d.sleep();
				
				}
			
			}
		
			CanvasManager.getSingleton().dispose();
			
			d.dispose();
			
		} catch (Exception e) {
			
			System.err.println(e);
			e.printStackTrace();
			
		}
		
	}
	
}
